Unit IIS8R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTII10_p;

procedure IIS8R(var XA :Array of Real; var YA :Array of Real;
                var Y2A :Array of Real; N :Integer; X :Real;
                var Y :Real; var IERR :Integer);

implementation

procedure IIS8R(var XA :Array of Real; var YA :Array of Real;
                var Y2A :Array of Real; N :Integer; X :Real;
                var Y :Real; var IERR :Integer);
var
KL0,KHI,K :Integer;
H,A,B :Real;
const
ZERO :Real = 0.0;
label
_1,_10,_20,_30,_40;
begin
IERR := 0;
KL0 := 1;
KHI := N;
_1:
if ( KHI-KL0 <= 1 ) 
 then goto _20;
K := (KHI+KL0) div 2;
if ( XA[K-1] <= X ) 
 then goto _10;
KHI := K;
goto _1;
_10:
KL0 := K;
goto _1;
_20:
H := XA[KHI-1]-XA[KL0-1];
if ( H > ZERO ) 
 then goto _30;
IERR := 65;
UTII10(IERR,8);
goto _40;
_30:
A := (XA[KHI-1]-X)/H;
B := (X-XA[KL0-1])/H;
Y := A*YA[KL0-1]+B*YA[KHI-1]+((IntPower(A,3)-A)*Y2A[KL0-1]+
    (IntPower(B,3)-B)*Y2A[KHI-1])*(IntPower(H,2))/6.0;
_40:
end;

end.
